/*********************************************************************************
*	Chicken Mod - 1.0.5
*	Official site - www.joe.to/chicken
*
*	This Version was created by OLO											
*   http://forums.unitedadmins.com/attachment.php?s=&postid=31796	
*
*	Brought to you by OLO, [DsV]T(+)rget and dJeyL
*   http://djeyl.net/chickenmod.php
*																			
*	SMA Fixed by [DsV]T(+)rget and dJeyL
*																			
*
* Changes/Fixes
*
* # 1.0.5
*   Removed local variables that were redundant with ChickenMod CVARs
*       (just use your server.cfg to set your values instead of recompiling)
*   Added value printing when config commands called with no parameter
*   Changed chickenteam commands, now using localinfo to get player teams
*   Removed Team Glowing, not yet in metamod plugin
*   Renamed command admin_chicken_life to admin_chicken_health
*       (only functions need to have their name < 20 char.)
*   Standardized config functions
*   Added 'health protection', that prevents or not from specifying health > 255
*   Added admin commands :
*       admin_chicken_egg (0 or 1)
*       admin_chicken_bomb (0 or 1)
*       admin_chicken_gravity (# percent, > 0)
*       admin_chicken_maxspeed
*       admin_chicken_hprotect (0 or 1)
* 
* # 1.0.3.1
*	Changed the way a player changes name
*		Chicken #(UserID) So you can unchicken easier, admin_unchicken (UserID)
*	Added New Admin Commands:-
*		admin_unchickenteam (1 or 2)
*		admin_chicken_life (1 - 255)
*		admin_chicken_glow (0 or 1)
*	Added Player & Team Glowing (Note player glowing can be controlled in-game)
*	Added a Cow sound when you get unchickened
*	Removed Say & Say_Team chicken msg's															
*	Fixed some msg's
*
*********************************************************************************/
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CHICKEN 8192
#define FLAG_INVALID 0
#define FLAG_CHICKEN 1

/************************ CHICKEN CONFIGURATION **************************/

// Sets health protection ON or OFF
// 1: ON : health can't be > 255
// 0: OFF: health has no theorical limit but will not be printed correctly in game
new HealthProtect = 1;

/************************ END OF CONFIGURATION ***************************/

new UserFlags[33] = {FLAG_INVALID,...};
new UserOldName[33][MAX_NAME_LENGTH];
new STRING_VERSION[MAX_DATA_LENGTH] = "1.0.5";

chicken_sound(sndno) {
  new i;
  new iMaxPlayers = maxplayercount();
  new Name[MAX_NAME_LENGTH];
  new UserID;
  new WONID;

  if(sndno == 0) {
    if (getvar("admin_fx") != 0) {
      for (i = 1; i <= iMaxPlayers; i++) {
  	  if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
          playsound(Name, "sound/misc/chicken0");
        }
      }
    }
  } else if(sndno == 1) {
    if (getvar("admin_fx") != 0) {
      for (i = 1; i <= iMaxPlayers; i++) {
  	  if (playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID) != 0) {
          playsound(Name, "sound/misc/cow");
        }
      }
    }
  }
}

public admin_chicken(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new MyIndex;
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	get_username(Data,TargetName,MAX_NAME_LENGTH);
	get_userindex(TargetName,MyIndex);
	
	if (check_user(Data) == 1 && UserFlags[MyIndex] == FLAG_INVALID) {
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		get_userindex(TargetName,MyIndex);
		say_command(User,Command,TargetName);
		
		UserFlags[MyIndex] = FLAG_CHICKEN;
		strcpy(UserOldName[MyIndex],TargetName,MAX_NAME_LENGTH);
		snprintf(Msg, MAX_DATA_LENGTH, "name ^"Chicken #%i^"", MyIndex);
		execclient(TargetName, Msg);
		snprintf(ExecText, MAX_TEXT_LENGTH, "c_chicken # %i", MyIndex);
		exec(ExecText);
		chicken_sound(0);
		snprintf(Text, MAX_TEXT_LENGTH, "%s has been transformed into a chicken", UserOldName[MyIndex]);
		typesay(Text, 10,255,25,255);
	} else {
		selfmessage("Already chicken or unrecognized player :");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

public admin_unchicken(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new MyIndex;
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	if (check_user(Data) == 1) {

		get_username(Data,TargetName,MAX_NAME_LENGTH);
		get_userindex(TargetName,MyIndex);

		say_command(User,Command,TargetName);
		
		if (strlen(UserOldName[MyIndex])!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "name ^"%s^"", UserOldName[MyIndex]);
			execclient(TargetName, Text);
		} else {
			snprintf(Msg, MAX_DATA_LENGTH, "name ^"NotAChicken #%i^"", MyIndex);
			execclient(TargetName, Msg);
		}
		snprintf(Text, MAX_TEXT_LENGTH, "%s is restored to human form", UserOldName[MyIndex]);
		typesay(Text, 10,255,25,255);
		snprintf(ExecText, MAX_TEXT_LENGTH, "c_unchicken # %i", MyIndex);
		exec(ExecText);
		chicken_sound(1);
		UserFlags[MyIndex] = FLAG_INVALID;
	} else {
		selfmessage("Unrecognized player :");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

public admin_chickenteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new WhichTeam;
	new TargetName[MAX_NAME_LENGTH];
	new Team;
	new TeamName[MAX_DATA_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new WONID;
	new MyIndex;

	new RealTeam;
	new RT[MAX_TEXT_LENGTH];
	new TeamInfo[MAX_TEXT_LENGTH];

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	WhichTeam = strtonum(Data);

	if(WhichTeam > 0 && WhichTeam < 3) {
		for(i=1; i<=maxplayers; i++) {
			strinit(TargetName);
			if(playerinfo(i,TargetName,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
				get_userindex(TargetName,MyIndex);
				snprintf(TeamInfo,MAX_TEXT_LENGTH,"p%d_team",i);
				get_serverinfo(TeamInfo,RT,MAX_TEXT_LENGTH);
				if(streq(RT,"TERRORIST")) {
				    RealTeam = 1;
				} else if(streq(RT,"CT")) {
				    RealTeam = 2;
				} else {
				    RealTeam = Team;
				}
				if(RealTeam==WhichTeam && UserFlags[MyIndex] == FLAG_INVALID) {
					UserFlags[MyIndex] = FLAG_CHICKEN;
					strcpy(UserOldName[MyIndex],TargetName,MAX_NAME_LENGTH);
					snprintf(Msg, MAX_DATA_LENGTH, "name ^"Chicken #%i^"", MyIndex);
					execclient(TargetName, Msg);
					snprintf(ExecText, MAX_TEXT_LENGTH, "c_chicken # %i", MyIndex);
					exec(ExecText);
				}
			}
		}
		if(WhichTeam == 1) {
			TeamName = "Terrorists";
		}
		else if(WhichTeam == 2) {
			TeamName = "Counter-Terrorists";
		}
		snprintf(ExecText, MAX_TEXT_LENGTH, "%s have been turned into chickens",TeamName);
		typesay(ExecText, 10,255,25,255);
		chicken_sound(0);
	} else {
		selfmessage("The team must be a number : 1 Terrorists, 2 Counter-Terrorists");
	}
	return PLUGIN_HANDLED;
}

public admin_unchickenteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new WhichTeam;
	new TargetName[MAX_NAME_LENGTH];
	new Team;
	new TeamName[MAX_DATA_LENGTH];
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new WONID;
	new MyIndex;

	new RealTeam;
	new RT[MAX_TEXT_LENGTH];
	new TeamInfo[MAX_TEXT_LENGTH];

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	WhichTeam = strtonum(Data);

	if(WhichTeam > 0 && WhichTeam < 3) {
		for(i=1; i<=maxplayers; i++) {
			strinit(TargetName);
			if(playerinfo(i,TargetName,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
				get_userindex(TargetName,MyIndex);
				snprintf(TeamInfo,MAX_TEXT_LENGTH,"p%d_team",i);
				get_serverinfo(TeamInfo,RT,MAX_TEXT_LENGTH);
				if(streq(RT,"TERRORIST")) {
				    RealTeam = 1;
				} else if(streq(RT,"CT")) {
				    RealTeam = 2;
				} else {
				    RealTeam = Team;
				}
				if(RealTeam==WhichTeam && UserFlags[MyIndex] == FLAG_CHICKEN) {
					UserFlags[MyIndex] = FLAG_INVALID;
					snprintf(ExecText, MAX_TEXT_LENGTH, "c_unchicken # %i", MyIndex);
					exec(ExecText);
					if(strlen(UserOldName[MyIndex])!=0) {
						snprintf(ExecText, MAX_TEXT_LENGTH, "name ^"%s^"", UserOldName[MyIndex]);
						execclient(TargetName, ExecText);
					} else {
						snprintf(Msg, MAX_DATA_LENGTH, "name ^"NotAChicken #%i^"", MyIndex);
						execclient(TargetName, Msg);
					}
				}
			}
		}
		if(WhichTeam == 1) {
			TeamName = "Terrorists";
		}
		else if(WhichTeam == 2) {
			TeamName = "Counter-Terrorists";
		}
		snprintf(ExecText, MAX_TEXT_LENGTH, "%s are restored to human form",TeamName);
		typesay(ExecText, 10,255,25,255);
		chicken_sound(1);
	} else {
		selfmessage("The team must be a number : 1 Terrorists, 2 Counter-Terrorists");
	}
	return PLUGIN_HANDLED;
}

public admin_unchickenall(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new TargetName[MAX_NAME_LENGTH];
	new Team;
	new ExecText[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new WONID;
	new MyIndex;

	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	for(i=1; i<=maxplayers; i++) {
		strinit(TargetName);
		strinit(ExecText);
		if(playerinfo(i,TargetName,MAX_NAME_LENGTH,SessionID,WONID,Team)==1) {
			get_userindex(TargetName,MyIndex);
			if (UserFlags[MyIndex] == FLAG_CHICKEN) {
				UserFlags[MyIndex] = FLAG_INVALID;
				if (strlen(UserOldName[MyIndex])!=0) {
					snprintf(ExecText, MAX_TEXT_LENGTH, "name ^"%s^"", UserOldName[MyIndex]);
					execclient(TargetName, ExecText);
				} else {
					snprintf(Msg, MAX_DATA_LENGTH, "name ^"NotAChicken #%i^"", MyIndex);
					execclient(TargetName, Msg);
				}
				snprintf(ExecText, MAX_TEXT_LENGTH, "c_unchicken # %i", MyIndex);
				exec(ExecText);
				chicken_sound(1);
			}
		}
	}
	typesay("Everyone is restored to human form", 10,255,25,255);
	return PLUGIN_HANDLED;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserFlags[UserIndex] = FLAG_INVALID;
		strinit(UserOldName[UserIndex]);
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		UserFlags[UserIndex] = FLAG_INVALID;
		strinit(UserOldName[UserIndex]);
	}
	return PLUGIN_CONTINUE;
}

public plugin_info(HLOldName,HLNewName,UserIndex) {
	new Msg[MAX_DATA_LENGTH];
	new NewName[MAX_NAME_LENGTH];
	new OldName[MAX_NAME_LENGTH];

	convert_string(HLNewName, NewName, MAX_NAME_LENGTH);
	convert_string(HLOldName, OldName, MAX_NAME_LENGTH);

	if(streq(OldName,NewName)==0) {
		if (UserFlags[UserIndex] == FLAG_CHICKEN) {
			snprintf(Msg, MAX_DATA_LENGTH, "name ^"Chicken #%i^"", UserIndex);
			execclient(OldName, Msg);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public admin_chicken_glow(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)==0) {
		if(getvar("c_glow")==0) {
		  selfmessage("Chicken Glowing is currently : OFF");
		} else {
		  selfmessage("Chicken Glowing is currently : ON");
		}
  	}
	else if(strtonum(Data)==0 && getvar("c_glow")) {
		exec("c_glow 0");
		say("[CHICKEN] The Admin has DISABLED chicken glowing");
		selfmessage("Chicken Glowing is now OFF");
	}
	else if(getvar("c_glow")==0) {
		exec("c_glow 1");
		say("[CHICKEN] The Admin has ENABLED chicken glowing");
		selfmessage("Chicken Glowing is now ON");
	}

	return PLUGIN_HANDLED;
}

public admin_chicken_egg(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)==0) {
		if(getvar("c_egg")==0) {
		  selfmessage("Chicken Egg Dropping is currently : OFF");
		} else {
		  selfmessage("Chicken Egg Dropping is currently : ON");
		}
  	}
	else if(strtonum(Data)==0 && getvar("c_egg")) {
		exec("c_egg 0");
		say("[CHICKEN] The Admin has DISABLED chicken egg dropping");
		selfmessage("Chicken Egg Dropping is now OFF");
	}
	else if(getvar("c_egg")==0) {
		exec("c_egg 1");
		say("[CHICKEN] The Admin has ENABLED chicken egg dropping");
		selfmessage("Chicken Egg Dropping is now ON");
	}

	return PLUGIN_HANDLED;
}

public admin_chicken_bomb(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)==0) {
		if(getvar("c_bomb")==0) {
		  selfmessage("Chicken Bomb Planting is currently : OFF");
		} else {
		  selfmessage("Chicken Bomb Planting is currently : ON");
		}
  	}
	else if(strtonum(Data)==0 && getvar("c_bomb")) {
		exec("c_bomb 0");
		say("[CHICKEN] The Admin has DISABLED chicken bomb planting");
		selfmessage("Chicken Bomb Planting is now OFF");
	}
	else if(getvar("c_bomb")==0) {
		exec("c_bomb 1");
		say("[CHICKEN] The Admin has ENABLED chicken bomb planting");
		selfmessage("Chicken Bomb Planting is now ON");
	}

	return PLUGIN_HANDLED;
}

public admin_chicken_hprot(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)==0) {
		if(HealthProtect==0) {
		  selfmessage("Health Protection is currently : OFF");
		} else {
		  selfmessage("Health Protection is currently : ON");
		}
  	}
	else if(strtonum(Data)==0 && HealthProtect) {
		HealthProtect = 0;
		selfmessage("Health Protection is now OFF");
	}
	else if(HealthProtect==0) {
		HealthProtect = 1;
		selfmessage("Health Protection is now ON");
		if(getvar("c_health")>255) {
		  exec("c_health 255");
		  selfmessage("Chickens Health is now set to : 255");
		  say("[CHICKEN] The Admin has set chickens HEALTH to : 255");
  		}
	}

	return PLUGIN_HANDLED;
}

public admin_chicken_life(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_NAME_LENGTH];
	new msg[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	new iData = strtonum(Data);
	
	if (iData > 0) {
	    if(iData <= 255 || HealthProtect == 0) {
	    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Health is now set to : %i",iData);
	    		selfmessage(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"[CHICKEN] The Admin has set chickens HEALTH to : %i",iData);
	    		say(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"c_health %i",iData);
	    		exec(msg);
   		}
   		else {
   		     exec("c_health 255");
   		     selfmessage("Chickens Health is now set to 255 because of Health Protection");
   		     say("[CHICKEN] The Admin has set chickens HEALTH : 255");
   		}
	} else {
	    if(strlen(Data)==0) {
    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Health is currently : %i",getvar("c_health"));
    		selfmessage(msg);
	    }
	    else if(HealthProtect==0) {
	    		selfmessage("INVALID NUMBER : please choose a number > 0");
	    } else {
	    		selfmessage("INVALID NUMBER : please choose a number from 1 to 255");
		}
	}
	return PLUGIN_HANDLED;
}

public admin_chicken_grav(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_NAME_LENGTH];
	new msg[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	new iData = strtonum(Data);
	
	if (iData > 0) {
	    if(iData!=getvar("c_gravity")) {
	    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Gravity is now set to : %i%%",iData);
	    		selfmessage(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"[CHICKEN] The Admin has set chickens GRAVITY to : %i percent",iData);
	    		say(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"c_gravity %i",iData);
	    		exec(msg);
   		}
	} else {
	    if(strlen(Data)==0) {
    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Gravity is currently : %i%%",getvar("c_gravity"));
    		selfmessage(msg);
	    }
	    else {
	    		selfmessage("INVALID NUMBER : please choose a number > 0");
	    }
	}
	return PLUGIN_HANDLED;
}

public admin_chicken_sp(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_NAME_LENGTH];
	new msg[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	new iData = strtonum(Data);
	
	if (iData > 0) {
	    if(iData!=getvar("c_maxspeed")) {
	    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Max Speed is now set to : %i",iData);
	    		selfmessage(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"[CHICKEN] The Admin has set chickens MAX SPEED to : %i",iData);
	    		say(msg);
	    		snprintf(msg,MAX_DATA_LENGTH,"c_maxspeed %i",iData);
	    		exec(msg);
   		}
	} else {
	    if(strlen(Data)==0) {
    		snprintf(msg,MAX_DATA_LENGTH,"Chickens Max Speed is currently : %i",getvar("c_maxspeed"));
    		selfmessage(msg);
	    }
	    else {
	    	    if(getvar("c_maxspeed")!=0) {
	    	    	    snprintf(msg,MAX_DATA_LENGTH,"Chickens now have maximum speed");
	    	    	    selfmessage(msg);
	    	    	    snprintf(msg,MAX_DATA_LENGTH,"[CHICKEN] The Admin has given MAXIMUM SPEED to chickens");
	    	    	    say(msg);
	    	    	    snprintf(msg,MAX_DATA_LENGTH,"c_maxspeed %i",iData);
	    	    	    exec(msg);
	    	    }
	    }
	}
	return PLUGIN_HANDLED;
}

public plugin_init() {
	plugin_registerinfo("Admin Chicken Plugin","Interface for Chicken Mod",STRING_VERSION);

	plugin_registercmd("admin_chicken","admin_chicken",ACCESS_CHICKEN,"admin_chicken <target>: chicken-fy target");
	plugin_registercmd("admin_unchicken","admin_unchicken",ACCESS_CHICKEN,"admin_unchicken <target>: unchicken-fy target");
	plugin_registercmd("admin_chickenteam","admin_chickenteam",ACCESS_CHICKEN,"admin_chickenteam <#>: chicken-fy team (1 = Terrorists, 2 = Counter-Terrorists)");
	plugin_registercmd("admin_unchickenteam","admin_unchickenteam",ACCESS_CHICKEN,"admin_unchickenteam <#>: unchicken-fy team (1 = Terrorists, 2 = Counter-Terrorists)");
	plugin_registercmd("admin_unchickenall","admin_unchickenall",ACCESS_CHICKEN,"admin_unchickenall: unchicken-fy all players");

	plugin_registercmd("admin_chicken_glow","admin_chicken_glow",ACCESS_CHICKEN,"admin_chicken_glow <0/1>: prints / sets chickens glowing off or on");
	plugin_registercmd("admin_chicken_hprotect","admin_chicken_hprot",ACCESS_CHICKEN,"admin_chicken_hprotect <0/1>: prints / sets chickens health protection");
	plugin_registercmd("admin_chicken_egg","admin_chicken_egg",ACCESS_CHICKEN,"admin_chicken_egg <0/1>: prints / sets chickens ability to drop he grenades as eggs");
	plugin_registercmd("admin_chicken_bomb","admin_chicken_bomb",ACCESS_CHICKEN,"admin_chicken_bomb <0/1>: prints / sets chickens ability to plant the bomb");
	plugin_registercmd("admin_chicken_health","admin_chicken_life",ACCESS_CHICKEN,"admin_chicken_health <#>: prints / sets chickens health");
	plugin_registercmd("admin_chicken_gravity","admin_chicken_grav",ACCESS_CHICKEN,"admin_chicken_gravity <#>: prints / sets chickens gravity (% of normal)");
	plugin_registercmd("admin_chicken_maxspeed","admin_chicken_sp",ACCESS_CHICKEN,"admin_chicken_maxspeed <#>: prints / sets chickens maxspeed (0 for max)");
	
	return PLUGIN_CONTINUE;	
}

