#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "chicken.h"

char team_name[10][32];
int	team_num = 0;

void UTIL_LogPrintf( char *fmt, ... ){
	va_list	argptr;
	static char	string[1024];
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );
	ALERT( at_logged, "%s", string );
}

char* UTIL_VarArgs( char *fmt, ... ){
	va_list	argptr;
	static char	string[1024];
	va_start (argptr, fmt);
	vsprintf (string, fmt,argptr);
	va_end (argptr);
	return string;
}
/*
char* GetModDir() {
  static char dir[256];
  GET_GAME_DIR(dir);
  int i = strlen(dir)-1;
  while ( i && dir[i] != '/' ) 
	  --i;
  return i ? &dir[++i] : NULL;
}
*/

void UpdateNumbers()
{
	player_t*pPlayer;
	int alive = 0;
	int chickens = 0;
	for(int i = 1; i <= gpGlobals->maxClients; ++i) {
		pPlayer = INDEXPLAYER(i);
		if (!pPlayer->ingame || !pPlayer->pChicken) continue;
		++chickens;
		if (pPlayer->pEdict->v.deadflag == DEAD_NO)
			++alive;
	}

	CVAR_SET_STRING("c_alive",UTIL_VarArgs("%d",alive)); //by string (not by float) to trunk .000000
	CVAR_SET_STRING("c_chickens",UTIL_VarArgs("%d",chickens));
}

// used to check if argument specifing the player
bool CallsMe(player_t* pPlayer, const char* arg, int parm){
	if ( !parm)	return true; //all
	if ( parm == 2 && !strcmp( GETTEAMNAME(pPlayer->team) , arg ) ) return true;//team
	if ( parm == 1 && pPlayer->index == atoi(arg) ) return true;//id
	if ( parm == 3 && strstr( STRING( pPlayer->pEdict->v.netname ), arg ) ) return true;//part of nick
	return false;
}

void c_unchicken( void ) {
	const char* arg = "";
	const char* arg1 = CMD_ARGV(1);
	const char* arg2 = CMD_ARGV(2);
	int argc = CMD_ARGC();
	int	parm = 0;
	if (argc == 3 && arg1[0] == '#' && !arg1[1]){
		arg = arg2;
		parm = 1;
	}
	else if (argc == 3 && arg1[0] == '@' && !arg1[1]){
		arg = arg2;
		parm = 2;
	}
	else if (argc == 2){
		arg = arg1;
		parm = 3;
	}
	player_t* pPlayer;
	for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
		pPlayer = INDEXPLAYER(i);
		if (pPlayer->ingame && pPlayer->pChicken && CallsMe(pPlayer,arg ,parm ) ){
			REMOVE_ENTITY( pPlayer->pChicken );
			pPlayer->pChicken = NULL;
			pPlayer->pEdict->v.renderamt = 255;
			pPlayer->pEdict->v.rendermode = kRenderNormal;
			if (pPlayer->pEdict->v.deadflag == DEAD_NO)
				pPlayer->pEdict->v.viewmodel = 	pPlayer->viewmodel;
			if ( pPlayer->pEdict->v.health > 100 ) 
				pPlayer->pEdict->v.health = 100;
			pPlayer->pEdict->v.view_ofs = pPlayer->view_ofs;
			pPlayer->pEdict->v.gravity = pPlayer->gravity;
			SETCLIENTMAXSPEED( pPlayer->pEdict, pPlayer->maxspeed );
			ENTITY_SET_KEYVALUE(pPlayer->pEdict,"cl_lw","1");
		}
	}

	UpdateNumbers();
}

void c_chicken( void ) {
	const char* arg = "";
	const char* arg1 = CMD_ARGV(1);
	const char* arg2 = CMD_ARGV(2);
	int argc = CMD_ARGC();
	int	parm = 0;
	if (argc == 3 && arg1[0] == '#' && !arg1[1]){ // c_chicken # id
		arg = arg2;
		parm = 1;
	}
	else if (argc == 3 && arg1[0] == '@' && !arg1[1]){ // c_chicken @ team
		arg = arg2;
		parm = 2;
	}
	else if (argc == 2){ // c_chicken name
		arg = arg1;
		parm = 3;
	}
	player_t* pPlayer;
	for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
		pPlayer = INDEXPLAYER(i);
		if (pPlayer->ingame && !pPlayer->pChicken && CallsMe(pPlayer,arg ,parm) ){	
			edict_t *pChicken = CREATE_NAMED_ENTITY( MAKE_STRING("info_target") );
			pPlayer->pChicken = pChicken;
			pChicken->v.classname = MAKE_STRING("chicken");
			pChicken->v.owner = pChicken->v.euser4 = pPlayer->pEdict;
			pChicken->v.takedamage = DAMAGE_NO;
			pChicken->v.solid = SOLID_NOT;
			pChicken->v.movetype = MOVETYPE_FLY;
			pChicken->v.renderfx = kRenderFxNone;
			pChicken->v.rendermode = kRenderNormal;
			pChicken->v.renderamt = 255;
			if (pPlayer->pEdict->v.deadflag == DEAD_DEAD || pPlayer->pEdict->v.deadflag == DEAD_DYING)//if dead
				pChicken->v.effects |= EF_NODRAW; //make invisible if dead
			pPlayer->gravity = pPlayer->pEdict->v.gravity;
			SET_ORIGIN(pChicken, (const Vector)pPlayer->pEdict->v.origin);
			SET_MODEL(pChicken, "models/chick.mdl");
			MDLL_Spawn( pChicken);
			pPlayer->pEdict->v.health = (c_health->value > 0 /* && c_health->value < 256 */) ? c_health->value : 100 ;
			SETCLIENTMAXSPEED( pPlayer->pEdict, c_maxspeed->value );
			ENTITY_SET_KEYVALUE(pPlayer->pEdict,"cl_lw","0");
			
			if(c_glow->value)
			{
			  Glow(pPlayer);
			}
		}
	}

	UpdateNumbers();
}

void Client_ResetHUD(void* value){
	player_t*pPlayer = INDEXPLAYER(entindex);
	if (pPlayer->pChicken){ //if we are an chicken
		pPlayer->pEdict->v.health = (c_health->value > 0 /* && c_health->value < 256 */) ? c_health->value : 100 ;
		SETCLIENTMAXSPEED( pPlayer->pEdict, c_maxspeed->value );
		pPlayer->pChicken->v.effects &= ~EF_NODRAW;		// and make chicken visible again
	}
	pPlayer->dead = false;						// uncheck death status
}

void Client_SendAudio(void* value){
	switch (state++){ //catch who is sending radio command
	case 0:
		entindex = *(int*)value;
	}
}

void Client_Damage(void* value){
	switch (state++) {
	case 1:	
		int health = *(int*)value;

		if (!players[entindex].pChicken) break;
	
		if ( health )	
			players[entindex].make_feather = true;
		else
			break;

		if ( health > 20 && players[entindex].pEdict->v.deadflag == DEAD_NO)	{
			int iPitch = RANDOM_LONG(100,120);
			switch(RANDOM_LONG(0,3)){
			case 0:	EMIT_SOUND_DYN2( players[entindex].pEdict , CHAN_VOICE, "misc/chicken1.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 1: EMIT_SOUND_DYN2( players[entindex].pEdict , CHAN_VOICE, "misc/chicken2.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 2: EMIT_SOUND_DYN2( players[entindex].pEdict , CHAN_VOICE, "misc/chicken3.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 3: EMIT_SOUND_DYN2( players[entindex].pEdict , CHAN_VOICE, "misc/chicken4.wav", 1, ATTN_NORM, 0, iPitch );break;
			}
		}
	}
}

void Client_TeamInfo(void* value){	
	static int index;
	switch (state++){
	case 0:
		index = *(int*)value;
		break;
	case 1:
		char* team = (char*)value;
		int i;
		for(i = 0; i < team_num ; ++i)
			if ( strcmpi( GETTEAMNAME(i) , team) == 0 )
				break;
		if ( i == team_num ) //copy only new names of team (var i reaches max value)
			strcpy( team_name[team_num++], team);
		player_t*pPlayer=INDEXPLAYER(index);
		pPlayer->pEdict=INDEXENT(index); // small reinitialization - some bots need that (coz they don't pass through PutInServer)
		if (!pPlayer->ingame)
			pPlayer->fake = true;
		pPlayer->ingame=true;
		pPlayer->index=index;
		pPlayer->team=i;
		SET_LOCALINFO(UTIL_VarArgs("p%d_team",index),team); //f.e.: "localinfo p1_team TERRORIST"
		//useful in AM plugins (better then original function from AM coz have also UNASSIGNED and SPECTATORS)
	}
}

void Glow(player_t* pPlayer) {

  pPlayer->pChicken->v.renderfx = kRenderFxGlowShell;
  pPlayer->pChicken->v.renderamt = 25;
  pPlayer->pChicken->v.rendercolor = Vector(0,0,0);

  pPlayer->glowteam = pPlayer->team;
  
  if(!strcmp("CT",GETTEAMNAME(pPlayer->team)) )
    {
      pPlayer->pChicken->v.rendercolor.z = 250;
    }
  else if(!strcmp("TERRORIST",GETTEAMNAME(pPlayer->team)) )
    {
      pPlayer->pChicken->v.rendercolor.x = 250;
    }
  else // glow yellow
    {
      pPlayer->pChicken->v.rendercolor.x = 250;
      pPlayer->pChicken->v.rendercolor.y = 250;				
    }

}
