
#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include <entity_state.h>
#include "chicken.h"

player_t players[33];
player_t *bombplanter;

void MAKE_GIBS( entvars_t *pev, int velocity, int rand, int gibs  ) {
	// gibs
	Vector vecSpot = pev->origin + (pev->mins + pev->maxs) * 0.2;
	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, (const Vector) vecSpot );
		WRITE_BYTE( TE_BREAKMODEL);
		// position
		WRITE_COORD( vecSpot.x );
		WRITE_COORD( vecSpot.y );
		WRITE_COORD( vecSpot.z );
		// size
		WRITE_COORD(  pev->size.x );
		WRITE_COORD(  pev->size.y );
		WRITE_COORD(  pev->size.z );
		// velocity
		WRITE_COORD( 0 ); 
		WRITE_COORD( 0 );
		WRITE_COORD( velocity ); //10
		// randomization
		WRITE_BYTE( rand ); //30
		// Model
		WRITE_SHORT( feather );	//model id#
		// # of shards
		WRITE_BYTE( gibs ); //30
		// duration
		WRITE_BYTE( 300 );// 15.0 seconds
		// flags
		WRITE_BYTE( BREAK_FLESH );
	MESSAGE_END();
}



float checktime;

void StartFrame( void )
{
	if (checktime < gpGlobals->time){
		checktime = gpGlobals->time + 1.0;
		static int last_maxspeed = (int) c_maxspeed->value;
		static int last_glow = (int) c_glow->value;
				
		if (last_maxspeed != c_maxspeed->value){
			player_t*pPlayer;
			for(int i = 1; i <=gpGlobals->maxClients;++i){
				pPlayer = INDEXPLAYER(i); 
				if (pPlayer->ingame && pPlayer->pChicken)
					SETCLIENTMAXSPEED( pPlayer->pEdict, c_maxspeed->value );
			}

			last_maxspeed = (int) c_maxspeed->value;
		}

		if (last_glow != c_glow->value) {
			player_t*pPlayer;
			for(int i = 1; i <=gpGlobals->maxClients;++i){
				pPlayer = INDEXPLAYER(i);
				if (pPlayer->ingame && pPlayer->pChicken)
				{
					pPlayer->pChicken->v.rendercolor = Vector(0,0,0);
					pPlayer->pChicken->v.renderfx = kRenderFxNone;
					pPlayer->pChicken->v.renderamt = 255;
					if (c_glow->value)
					{
					  Glow(pPlayer);
					}
				}
			}

			last_glow = (int) c_glow->value;
		}
		else if (c_glow->value) {
		  player_t*pPlayer;

		  for(int i = 1; i <= gpGlobals->maxClients; ++i) {
		    pPlayer = INDEXPLAYER(i);
		    if (pPlayer->ingame && pPlayer->pChicken)
		      {
			if (pPlayer->glowteam != pPlayer->team)
			  {
			    Glow(pPlayer);
			  }
		      }
		  }

		}
	}
	
	RETURN_META(MRES_IGNORED);
}


void ClientPutInServer( edict_t *pEntity ) {  
	int index = ENTINDEX(pEntity);
	player_t *pPlayer = INDEXPLAYER(index);
	pPlayer->pEdict = pEntity;
	pPlayer->index = index;
	pPlayer->ingame = true;
	RETURN_META(MRES_IGNORED);
}

void PlayerPreThink( edict_t *pEntity ) {
	player_t *pPlayer = ENTPLAYER(pEntity);

	if ( !pPlayer->pChicken ) 
		RETURN_META(MRES_IGNORED); // no chicken, so don't make any actions

	entvars_t*ppev = &pEntity->v;
	entvars_t*pev = &pPlayer->pChicken->v;

	ppev->gravity = c_gravity->value / 100;					//change gravity
	ppev->rendermode = kRenderTransAdd;		//make player transparent
	ppev->renderamt = 0;

	if ( ppev->deadflag == DEAD_DEAD || ppev->deadflag == DEAD_DYING ){
		if ( !pPlayer->dead ){	//if dying then make noise and spawn some gibs
			pPlayer->dead = true;
			EMIT_SOUND_DYN2( pEntity, CHAN_VOICE, "misc/killChicken.wav", 1, ATTN_NORM, 0, 105 + RANDOM_LONG(0,9));
			MAKE_GIBS( pev , 5 , 30 , 30);
			UpdateNumbers();
		}
		pev->effects |= EF_NODRAW; //chicken also should be not visble
		RETURN_META(MRES_IGNORED);
	}
	else if ( pPlayer->make_feather )
	{
		pPlayer->make_feather = false;
		MAKE_GIBS( pev , 5 , 10 , 5 );
	}

	if ( ppev->viewmodel != 0 ) {				//weapon has changed 
		pPlayer->viewmodel = ppev->viewmodel;	//so rember to what
		if (!pPlayer->fake) {						// force player to use kinfe, or c4 / he if allowed by cvars
		  if(strncmp(STRING(ppev->viewmodel)+7,"v_knife.",8) && (!c_bomb->value || strncmp(STRING(ppev->viewmodel)+7,"v_c4.",5)) && (!c_egg->value || strncmp(STRING(ppev->viewmodel)+7,"v_hegrenade.",12)))
		    CLIENT_COMMAND(pEntity,"weapon_knife\n"); //don't allow to use other weapon then knife
			
		}
		if (strncmp(STRING(ppev->viewmodel)+7,"v_hegrenade.",12)) {
			bombplanter = pPlayer;
		}
		ppev->viewmodel = 0;					// and make current weapon invisible
	}

	if ( ppev->view_ofs != pev->view_ofs ){		//view ofset has changed
		pPlayer->view_ofs = ppev->view_ofs;		//remember to what
		ppev->view_ofs = pev->view_ofs;			//and force chicken view ofset
	}
	pev->origin.x = ppev->origin.x;
	pev->origin.y = ppev->origin.y;
	pev->origin.z = ppev->origin.z - ((ppev->flags & FL_DUCKING) ? 18 : 36); //during ducking make origin higher
	pev->angles.x = pev->angles.z = 0;
	pev->angles.y = ppev->v_angle.y - 90;
	RETURN_META(MRES_IGNORED);
}


void PlayerPostThink( edict_t *pEntity ) {
	player_t *pPlayer = ENTPLAYER(pEntity);

	if( !pPlayer->pChicken ) 
		RETURN_META(MRES_IGNORED);

	if (pEntity->v.button & (IN_ATTACK|IN_ATTACK2)) { //when attacking make some anime
		if( pPlayer->attack_time < gpGlobals->time ) {
			pPlayer->attack_time = gpGlobals->time + 2;
			pPlayer->pChicken->v.sequence = 1;
			pPlayer->pChicken->v.frame = 1;

		}
		if (pPlayer->fake){ //bots can't attack (they don't have knife in hands)
			pEntity->v.button &= ~(IN_ATTACK|IN_ATTACK2);
		}
	}

	if ( pPlayer->attack_time > gpGlobals->time )
		pPlayer->pChicken->v.frame++;

	RETURN_META(MRES_IGNORED);
}


void ClientDisconnect( edict_t *pEntity ) {
	player_t *pPlayer = ENTPLAYER(pEntity);
	if ( pPlayer->pChicken ) {
		REMOVE_ENTITY( pPlayer->pChicken ); //remove chicken
		pPlayer->pChicken = NULL;
	}
	pPlayer->ingame = false;
	pPlayer->fake = false;
	SET_LOCALINFO(UTIL_VarArgs("p%d_team",pPlayer->index),""); //remove team

	UpdateNumbers();

	RETURN_META(MRES_IGNORED);
}

int gmsgDamage = 0;
int gmsgSendAudio = 0;
int gmsgTeamInfo = 0;
int gmsgResetHUD = 0;
int feather;

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax ){
	memset(players,0,sizeof(players)); //reset players values on server restart
	feather = PRECACHE_MODEL( "models/feather.mdl" );
	PRECACHE_MODEL( "models/chick.mdl" );
	PRECACHE_MODEL( "models/w_chickenc4.mdl");
	PRECACHE_SOUND("misc/chicken0.wav");
	PRECACHE_SOUND("misc/chicken1.wav");
	PRECACHE_SOUND("misc/chicken2.wav");
	PRECACHE_SOUND("misc/chicken3.wav");
	PRECACHE_SOUND("misc/chicken4.wav");
	PRECACHE_SOUND("misc/killChicken.wav");
	PRECACHE_SOUND("weapons/knife_hit1.wav");
	PRECACHE_SOUND("weapons/knife_hit3.wav");
	checktime = 0.0;
	if (!gmsgResetHUD) { //get some enigne values only once
		gmsgResetHUD = GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
		gmsgTeamInfo = GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
		gmsgSendAudio = GET_USER_MSG_ID(PLID, "SendAudio", NULL );
		gmsgDamage = GET_USER_MSG_ID(PLID, "Damage", NULL );
	}

	RETURN_META(MRES_IGNORED);
}

int AddToFullPack(struct entity_state_s *state, int e, edict_t *ent, edict_t *host, 
				  int hostflags, int player, unsigned char *pSet)
{

	if (!player && ent->v.euser4 == host) //don't send chicken to owner
		RETURN_META_VALUE(MRES_SUPERCEDE, 0);

	RETURN_META_VALUE(MRES_IGNORED, 0);
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable.pfnAddToFullPack = AddToFullPack;
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnPlayerPreThink = PlayerPreThink;
	gFunctionTable.pfnPlayerPostThink = PlayerPostThink;
	gFunctionTable.pfnClientPutInServer = ClientPutInServer;
	gFunctionTable.pfnStartFrame = StartFrame;
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

float lastsend;
int	end_msg;
int entindex;
int state;
void (*function)(void*);

void MessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
	function = NULL;
	state = 0;
	end_msg = msg_type;
	entindex = 0;
	if ( ed ){ //messages send to specified players
		if (msg_type == gmsgResetHUD){
			function = Client_ResetHUD;
			entindex = ENTINDEX(ed);
		}		
		else if (msg_type == gmsgSendAudio){
			function = Client_SendAudio;
		}
		else if (msg_type == gmsgDamage){
			function = Client_Damage;
			entindex = ENTINDEX(ed);
		}
	}
	else { //globaly
		if (msg_type == gmsgTeamInfo)
			function = Client_TeamInfo;
	}
	RETURN_META(MRES_IGNORED);
}

void MessageEnd(void) {
	if (function) (*function)(NULL);
	RETURN_META(MRES_IGNORED);
}

void WriteByte(int iValue) {
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteChar(int iValue) {
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteShort(int iValue) {
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteLong(int iValue) {
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteAngle(float flValue) {
	if (function) (*function)((void *)&flValue);
	RETURN_META(MRES_IGNORED);
}
void WriteCoord(float flValue) {
	if (function)	(*function)((void *)&flValue);
	RETURN_META(MRES_IGNORED);
}

void WriteString(const char *sz) {
	if (function == Client_SendAudio && state && players[entindex].pChicken){
		if (lastsend != gpGlobals->time){
			lastsend = gpGlobals->time;
			int iPitch = RANDOM_LONG(100,120);
			switch(RANDOM_LONG(0,3)){
			case 0:	EMIT_SOUND_DYN2( INDEXENT(entindex) , CHAN_VOICE, "misc/chicken1.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 1: EMIT_SOUND_DYN2( INDEXENT(entindex) , CHAN_VOICE, "misc/chicken2.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 2: EMIT_SOUND_DYN2( INDEXENT(entindex) , CHAN_VOICE, "misc/chicken3.wav", 1, ATTN_NORM, 0, iPitch );break;
			case 3: EMIT_SOUND_DYN2( INDEXENT(entindex) , CHAN_VOICE, "misc/chicken4.wav", 1, ATTN_NORM, 0, iPitch );break;
			}
		}
		WRITE_STRING("");
		RETURN_META(MRES_SUPERCEDE);
	}
	if (function)	(*function)((void *)sz);
	RETURN_META(MRES_IGNORED);
}
void WriteEntity(int iValue) {
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}

//Hook knife sound and replace to not resemble knife
void EmitSound(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch) {
	//weapons/knife: _hit1, _hit2, _hit3, _hit4, _hitwall1, _slash1, _slash2, _stab, _deploy
	//printf("sample=%s from=%s\n",sample,STRING(entity->v.netname));
	if (sample[0]=='w' && sample[1]=='e' && sample[8]=='k' && sample[9]=='n'){
		player_t*pPlayer = ENTPLAYER(entity);
		if (!pPlayer->pChicken) RETURN_META(MRES_IGNORED); //only chickens
		if (sample[14]=='d') RETURN_META(MRES_SUPERCEDE); //deploy
		switch(sample[15]){
		case 'l': { //if not hiting then give a voice once on 3 seconds
			if (pPlayer->chicken_say < gpGlobals->time)	{
				pPlayer->chicken_say = gpGlobals->time + 3;
				int iPitch = RANDOM_LONG(100,120);
				switch(RANDOM_LONG(0,3)){
				case 0:	EMIT_SOUND_DYN2( entity , CHAN_VOICE, "misc/chicken1.wav", 1, ATTN_NORM, 0, iPitch );break;
				case 1: EMIT_SOUND_DYN2( entity , CHAN_VOICE, "misc/chicken2.wav", 1, ATTN_NORM, 0, iPitch );break;
				case 2: EMIT_SOUND_DYN2( entity, CHAN_VOICE, "misc/chicken3.wav", 1, ATTN_NORM, 0, iPitch );break;
				case 3: EMIT_SOUND_DYN2( entity , CHAN_VOICE, "misc/chicken4.wav", 1, ATTN_NORM, 0, iPitch );break;
				}
			}
			RETURN_META(MRES_SUPERCEDE);//slash
		}
		case 't': //stab
			EMIT_SOUND_DYN2(entity, channel,"weapons/knife_hit3.wav" ,volume,attenuation,fFlags,pitch);
			RETURN_META(MRES_SUPERCEDE);
		}
		switch(sample[17]){
		case '2': //((char*)sample)[17]='1'; 
			EMIT_SOUND_DYN2(entity, channel,"weapons/knife_hit1.wav" ,volume,attenuation,fFlags,pitch);
			RETURN_META(MRES_SUPERCEDE);// 2 -> 1
		case '4': //((char*)sample)[17]='3'; 
			EMIT_SOUND_DYN2(entity, channel,"weapons/knife_hit3.wav" ,volume,attenuation,fFlags,pitch);
			RETURN_META(MRES_SUPERCEDE);// 4 -> 3
		case 'w': RETURN_META(MRES_SUPERCEDE); //remove wallhit
		}
	}
	RETURN_META(MRES_IGNORED);
}

void SetClientMaxspeed(const edict_t *pEdict, float fNewMaxspeed){

	player_t *pPlayer = ENTPLAYER((edict_t *)pEdict);

	if( !pPlayer->pChicken ) {
		pPlayer->maxspeed = fNewMaxspeed;
		RETURN_META(MRES_IGNORED);
	}

	SETCLIENTMAXSPEED(pEdict,c_maxspeed->value);

	RETURN_META(MRES_SUPERCEDE);
}

void SetModel(edict_t *pEdict, const char *model){
	player_t* pPlayer;


	if(!strncmp(model+7,"w_hegrenade.",12)) {
		for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
			pPlayer = INDEXPLAYER(i);
			
			if(pPlayer->pEdict == pEdict->v.owner && pPlayer->pChicken) {
				SET_MODEL(pEdict,"models/w_chickenc4.mdl");
				/*				pEdict->v.velocity.x=0;
				pEdict->v.velocity.y=0;
				if (pEdict->v.velocity.z > 0)
				pEdict->v.velocity.z=0;*/
				pEdict->v.velocity=Vector(0,0,0);
				SET_ORIGIN(pEdict, (const Vector) pPlayer->pChicken->v.origin);
				RETURN_META(MRES_SUPERCEDE);
			}
		}
	}
	else if (!strncmp(model+7,"w_c4.",5) && bombplanter->pChicken) {
				SET_MODEL(pEdict,"models/w_chickenc4.mdl");
				RETURN_META(MRES_SUPERCEDE);
	}


	RETURN_META(MRES_IGNORED);
}

enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ){
	meta_engfuncs.pfnMessageBegin = MessageBegin;
	meta_engfuncs.pfnMessageEnd = MessageEnd;
	meta_engfuncs.pfnWriteByte = WriteByte;
	meta_engfuncs.pfnWriteChar = WriteChar;
	meta_engfuncs.pfnWriteShort = WriteShort;
	meta_engfuncs.pfnWriteLong = WriteLong;
	meta_engfuncs.pfnWriteAngle = WriteAngle;
	meta_engfuncs.pfnWriteCoord = WriteCoord;
	meta_engfuncs.pfnWriteString = WriteString;
	meta_engfuncs.pfnWriteEntity =  WriteEntity;
	meta_engfuncs.pfnEmitSound =  EmitSound;
	meta_engfuncs.pfnSetClientMaxspeed =  SetClientMaxspeed;
	meta_engfuncs.pfnSetModel = SetModel;
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}

META_FUNCTIONS gMetaFunctionTable = {
	NULL,
	NULL,
	GetEntityAPI2,
	GetEntityAPI2_Post,
	NULL,
	NULL,
	GetEngineFunctions,
	NULL,
};
